Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography Library 1.84
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.bouncycastle.crypto.modes
Class G3413CFBBlockCipher

    java.lang.Object
      org.bouncycastle.crypto.DefaultMultiBlockCipher
          org.bouncycastle.crypto.StreamBlockCipher
              org.bouncycastle.crypto.modes.G3413CFBBlockCipher

All Implemented Interfaces:
  BlockCipher, MultiBlockCipher, StreamCipher

public class G3413CFBBlockCipher
extends StreamBlockCipher

An implementation of the CFB mode for GOST 3412 2015 cipher. See GOST R 3413 2015

Constructor Summary
`G3413CFBBlockCipher(BlockCipher cipher)` Base constructor.
`G3413CFBBlockCipher(BlockCipher cipher, int bitBlockSize)` Base constructor with specific block size.

Method Summary
`protected byte` | `calculateByte(byte in)`
`java.lang.String` | `getAlgorithmName()` Return the name of the algorithm the cipher implements.
`int` | `getBlockSize()` Return the block size for this cipher (in bytes).
`void` | `init(boolean forEncryption, CipherParameters params)` Initialise the cipher and initialisation vector R.
`int` | `processBlock(byte[] in, int inOff, byte[] out, int outOff)` Process one block of input from the array in and write it to the out array.
`void` | `reset()` copy R_init into R and reset the underlying cipher.

Methods inherited from class org.bouncycastle.crypto.StreamBlockCipher
`getUnderlyingCipher, processBytes, returnByte`

Methods inherited from class org.bouncycastle.crypto.DefaultMultiBlockCipher
`getMultiBlockSize, processBlocks`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### G3413CFBBlockCipher

    public G3413CFBBlockCipher(BlockCipher cipher)

  Base constructor.

Parameters:
  `cipher` - base cipher

### G3413CFBBlockCipher

    public G3413CFBBlockCipher(BlockCipher cipher,
                               int bitBlockSize)

  Base constructor with specific block size.

Parameters:
  `cipher` - base cipher
  `bitBlockSize` - basic unit (defined as s)

Method Detail

### init

    public void init(boolean forEncryption,
                     CipherParameters params)
              throws java.lang.IllegalArgumentException

  Initialise the cipher and initialisation vector R. If an IV isn't passed as part of the parameter, the IV will be all zeros. An IV which is too short is handled in FIPS compliant fashion. R_init = IV, and R1 = R_init

  Parameters:
    `forEncryption` - ignored because encryption and decryption are same
    `params` - the key and other data required by the cipher.
  Throws:
    `java.lang.IllegalArgumentException`

### getAlgorithmName

    public java.lang.String getAlgorithmName()

  Description copied from interface: `StreamCipher`
  Return the name of the algorithm the cipher implements.

  Returns:
    the name of the algorithm the cipher implements.

### getBlockSize

    public int getBlockSize()

  Description copied from interface: `BlockCipher`
  Return the block size for this cipher (in bytes).

  Returns:
    the block size for this cipher in bytes.

### processBlock

    public int processBlock(byte[] in,
                            int inOff,
                            byte[] out,
                            int outOff)
                     throws DataLengthException,
                            java.lang.IllegalStateException

  Description copied from interface: `BlockCipher`
  Process one block of input from the array in and write it to the out array.

  Parameters:
    `in` - the array containing the input data.
    `inOff` - offset into the in array the data starts at.
    `out` - the array the output data will be copied into.
    `outOff` - the offset into the out array the output will start at.
  Returns:
    the number of bytes processed and produced.
  Throws:
    `java.lang.IllegalStateException` - if the cipher isn't initialised.
    `DataLengthException` - if there isn't enough data in input , or space in out.

### calculateByte

    protected byte calculateByte(byte in)

  Specified by:
    `calculateByte` in class `StreamBlockCipher`

### reset

    public void reset()

  copy R_init into R and reset the underlying cipher.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography Library 1.84
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD